import "core-js/modules/es.array.for-each";
import "core-js/modules/es.function.name";
import "core-js/modules/web.dom-collections.for-each";
import Vue from 'vue';
import cleanName from 'vue-docgen-api/dist/utils/cleanName';

var isEs6Export = function isEs6Export(module) {
  return !!module["default"];
};
/**
 * Expose component as global variables.
 *
 * @param {Object} component
 */


export default function globalizeComponent(component) {
  var displayName = component.props.displayName || '';

  if (!component.name) {
    return;
  }

  var configComponent = isEs6Export(component.module) ? component.module["default"] : component.module;

  if (configComponent) {
    Vue.component(cleanName(displayName), configComponent);
  }

  if (component.subComponents) {
    component.subComponents.forEach(function (c) {
      return globalizeComponent(c);
    });
  }
}