"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = findUserWebpackConfig;
var USER_WEBPACK_CONFIG_NAMES = ['./webpack.config.js', './webpackfile.js', '@vue/cli-service/webpack.config.js'];
/**
 * Find user’s Webpack config and return its path.
 * Fixed location for Create React App or webpack.config.js in the root directory.
 * Returns false if config not found.
 *
 * @return {string|boolean}
 */

function findUserWebpackConfig() {
  // Check in the root folder
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = USER_WEBPACK_CONFIG_NAMES[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var configFile = _step.value;

      try {
        return require.resolve(configFile);
      } catch (e) {// if file not found, eat the error
      }
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator["return"] != null) {
        _iterator["return"]();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  return false;
}